Content Class Reference

`#include <jinglecontent.h>`

Inheritance diagram for Content:
[legend]

## Public Types

enum | Creator { CInitiator , CResponder , InvalidCreator }
enum | Senders { SInitiator , SResponder , SBoth , SNone , InvalidSender }

## Public Member Functions

| Content (const std::string &name, const PluginList &plugins, Creator creator=CInitiator, Senders senders=SBoth, const std::string &disposition="session")
| Content (const Tag *tag=0, PluginFactory *factory=0)
Creator | creator () const
Senders | senders () const
const std::string & | disposition () const
const std::string & | name () const
virtual | ~Content ()
virtual const std::string & | filterString () const
virtual Tag * | tag () const
virtual Plugin * | newInstance (const Tag *tag) const
virtual Plugin * | clone () const
Public Member Functions inherited from Plugin
| Plugin (JinglePluginType type)
virtual | ~Plugin ()
void | addPlugin (const Plugin *plugin)
const Plugin * | findPlugin (int type) const
template<class T>
const T * | findPlugin (int type) const
const PluginList & | plugins () const
virtual const StringList | features () const
JinglePluginType | pluginType () const

## Detailed Description

An abstraction of a Jingle Content Type. This is part of Jingle (XEP-0166).

See Jingle::Session for more info on Jingle.

XEP Version: 1.1

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  1.0.5

Definition at line 41 of file jinglecontent.h.

## Member Enumeration Documentation

## Creator

enum Creator

The original creator of the content type.

Enumerator
CInitiator | The creator is the initiator of the session.
CResponder | The creator is the responder.
InvalidCreator | Invalid value.

Definition at line 47 of file jinglecontent.h.

## Senders

enum Senders

The parties in the session that will be generating content.

Enumerator
SInitiator | The initiator generates/sends content.
SResponder | The responder generates/sends content.
SBoth | Both parties generate/send content( default).
SNone | No party generates/sends content.
InvalidSender | Invalid value.

Definition at line 57 of file jinglecontent.h.

## Constructor & Destructor Documentation

## Content() [1/2]

Content | ( | const std::string & | name,
|  | const PluginList & | plugins,
|  | Creator | creator = CInitiator,
|  | Senders | senders = SBoth,
|  | const std::string & | disposition = "session" )

Creates a new Content wrapper.

Parameters

  name | A unique name for the content type.
  plugins | A list of application formats, transport methods, security preconditions, ...
  creator | Which party originally generated the content type; the defined values are "SInitiator" and "SResponder".
  senders | Which parties in the session will be generating content.
  disposition | How the content definition is to be interpreted by the recipient. The meaning of this attribute matches the "Content-Disposition" header as defined in RFC 2183 and applied to SIP by RFC 3261.

Definition at line 46 of file jinglecontent.cpp.

## Content() [2/2]

Content | ( | const Tag * | tag = 0,
|  | PluginFactory * | factory = 0 )

Creates a new Content object from the given tag.

Parameters

  tag | The Tag to parse.
  factory | A PluginFactory instance to use for embedding plugins.

Definition at line 54 of file jinglecontent.cpp.

## ~Content()

~Content | ( |  | ) |

virtual

Virtual destructor.

Definition at line 69 of file jinglecontent.cpp.

## Member Function Documentation

## clone()

Plugin * clone | ( |  | ) | const

virtual

Creates an identical deep copy of the current instance.

Returns
  An identical deep copy of the current instance.

Implements Plugin.

Definition at line 97 of file jinglecontent.cpp.

## creator()

Creator creator | ( |  | ) | const

inline

Returns the content's creator.

Returns
  The content's creator.

Definition at line 89 of file jinglecontent.h.

## disposition()

const std::string & disposition | ( |  | ) | const

inline

Returns the disposition.

Returns
  The disposition.

Definition at line 101 of file jinglecontent.h.

## filterString()

const std::string & filterString | ( |  | ) | const

virtual

Returns an XPath expression that describes a path to child elements of a jingle element that the plugin handles. The result should be a single Tag.

Returns
  The plugin's filter string.

Implements Plugin.

Definition at line 73 of file jinglecontent.cpp.

## name()

const std::string & name | ( |  | ) | const

inline

Returns the content name.

Returns
  The content name.

Definition at line 107 of file jinglecontent.h.

## newInstance()

virtual Plugin * newInstance | ( | const Tag * | tag | ) | const

inline virtual

Returns a new instance of the same plugin type, based on the Tag provided.

Parameters

  tag | The Tag to parse and create a new instance from.

Returns
  The new plugin instance.

Implements Plugin.

Definition at line 121 of file jinglecontent.h.

## senders()

Senders senders | ( |  | ) | const

inline

Returns the senders.

Returns
  The senders.

Definition at line 95 of file jinglecontent.h.

## tag()

Tag * tag | ( |  | ) | const

virtual

Returns a Tag representation of the plugin.

Returns
  A Tag representation of the plugin.

Implements Plugin.

Definition at line 79 of file jinglecontent.cpp.

The documentation for this class was generated from the following files:

- jinglecontent.h
- jinglecontent.cpp